package org.nuiton.topia.security.entities.user;

import java.util.Collection;
import java.util.List;
import org.nuiton.topia.persistence.TopiaEntity;
import org.nuiton.topia.security.listener.NoSecurityLoad;

public interface TopiaGroup extends NoSecurityLoad, TopiaEntity {

    String NAME = "name";

    String DESCRIPTION = "description";

    String TOPIA_USER = "topiaUser";

    String SUPER_GROUP = "superGroup";

    String SUB_GROUP = "subGroup";

    void setName(String name);

    String getName();

    void setDescription(String description);

    String getDescription();

    void addTopiaUser(TopiaUser topiaUser);

    void addAllTopiaUser(Collection<TopiaUser> topiaUser);

    void setTopiaUser(Collection<TopiaUser> topiaUser);

    void removeTopiaUser(TopiaUser topiaUser);

    void clearTopiaUser();

    Collection<TopiaUser> getTopiaUser();

    TopiaUser getTopiaUserByTopiaId(String topiaId);

    int sizeTopiaUser();

    boolean isTopiaUserEmpty();

    void setSuperGroup(TopiaGroup superGroup);

    TopiaGroup getSuperGroup();

    void addSubGroup(TopiaGroup subGroup);

    void addAllSubGroup(Collection<TopiaGroup> subGroup);

    void setSubGroup(Collection<TopiaGroup> subGroup);

    void removeSubGroup(TopiaGroup subGroup);

    void clearSubGroup();

    Collection<TopiaGroup> getSubGroup();

    TopiaGroup getSubGroupByTopiaId(String topiaId);

    int sizeSubGroup();

    boolean isSubGroupEmpty();

    List getAllUser();

    List getAllSuperGroup();

} //TopiaGroup
